import pyglet
from pyglet.window import key

window = pyglet.window.Window(width=400, height=300, caption="TestWindow")

label = pyglet.text.Label('Nothing pressed so far',
                          font_name='Times New Roman',
                          font_size=18,
                          x=50, y = 150)

@window.event
def on_key_press(symbol, modifiers):
    if symbol == key.A:
        key_pressed = "a"
    elif symbol == key.RETURN:
        key_pressed = "return"
    elif symbol == key.LEFT:
        key_pressed = "left arrow"
    else:
        key_pressed = 'unknown'
    global label
    label = pyglet.text.Label('You pressed the '+key_pressed+' key!',
                              font_name='Times New Roman',
                              font_size=18,
                              x=50, y = 150)

@window.event
def on_mouse_press(x, y, button, modifiers):
    global label
    label = pyglet.text.Label('Mouse click at position ('+str(x)+', '+str(y)+')',
                              font_name='Times New Roman',
                              font_size=18,
                              x=50, y = 150)

@window.event
def on_mouse_release(x, y, button, modifiers):
    global label
    label = pyglet.text.Label('Mouse released at position ('+str(x)+', '+str(y)+')',
                              font_name='Times New Roman',
                              font_size=18,
                              x=25, y = 150)

@window.event
def on_mouse_drag(x, y, dx, dy, button, modifiers):
    global label
    label = pyglet.text.Label('Mouse is dragging at position ('+str(x)+', '+str(y)+')',
                              font_name='Times New Roman',
                              font_size=18,
                              x=0, y = 150)


@window.event
def on_mouse_motion(x, y, dx, dy):
    global label
    label = pyglet.text.Label('Mouse is at position ('+str(x)+', '+str(y)+')',
                              font_name='Times New Roman',
                              font_size=18,
                              x=50, y = 150)

@window.event
def on_draw():
    window.clear()
    label.draw()

pyglet.app.run()

