from matplotlib.pyplot import subplots, show

fig, mainplot = subplots()
plot2 = mainplot.twinx()
plot3 = mainplot.twinx()
fig.subplots_adjust(right=0.75)

plot3.spines["right"].set_position(("axes", 1.15))

p1, = mainplot.plot([2000, 2004, 2006, 2010], [350, 550, 900, 700], "b", label="Fish")
p2, = plot2.plot([2000, 2009], [12, 17], "r", label="Bears")
p3, = plot3.plot([2000, 2002, 2004, 2006, 2008, 2010], [11, 13, 15, 18, 24, 29], "g", label="Eagles")

mainplot.set_xlim(2000, 2010)
mainplot.set_ylim(300, 1000)
plot2.set_ylim(0, 20)
plot3.set_ylim(0, 30)

mainplot.set_xlabel("Year")
mainplot.set_ylabel("Fish")
plot2.set_ylabel("Bears")
plot3.set_ylabel("Eagles")

mainplot.yaxis.label.set_color("b")
plot2.yaxis.label.set_color("r")
plot3.yaxis.label.set_color("g")

mainplot.tick_params(axis='y', colors = "b")
plot2.tick_params(axis='y', colors = "r")
plot3.tick_params(axis='y', colors = "g")


lines = [p1, p2, p3]
mainplot.legend(lines, [l.get_label() for l in lines])

show()